<?php
session_start();
include_once "conection/db.php"; 

require_once('PDF/tcpdf_include.php');

// create new PDF document
$pdf = new TCPDF(PDF_PAGE_ORIENTATION, PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false);


// set document information
$pdf->SetCreator(PDF_CREATOR);
$pdf->SetAuthor('Nicola Asuni');
$pdf->SetTitle('TCPDF Example 006');
$pdf->SetSubject('TCPDF Tutorial');
$pdf->SetKeywords('TCPDF, PDF, example, test, guide');

// set default header data
$pdf->SetHeaderData(PDF_HEADER_LOGO, PDF_HEADER_LOGO_WIDTH, PDF_HEADER_TITLE.' 006', PDF_HEADER_STRING);

// set header and footer fonts
$pdf->setHeaderFont(Array(PDF_FONT_NAME_MAIN, '', PDF_FONT_SIZE_MAIN));
$pdf->setFooterFont(Array(PDF_FONT_NAME_DATA, '', PDF_FONT_SIZE_DATA));

// set default monospaced font
$pdf->SetDefaultMonospacedFont(PDF_FONT_MONOSPACED);

// set margins
$pdf->SetMargins(PDF_MARGIN_LEFT, PDF_MARGIN_TOP, PDF_MARGIN_RIGHT);
$pdf->SetHeaderMargin(PDF_MARGIN_HEADER);
$pdf->SetFooterMargin(PDF_MARGIN_FOOTER);

// set auto page breaks
$pdf->SetAutoPageBreak(TRUE, PDF_MARGIN_BOTTOM);

// set image scale factor
$pdf->setImageScale(PDF_IMAGE_SCALE_RATIO);


// set some language-dependent strings (optional)
if (@file_exists(dirname(__FILE__).'/lang/eng.php')) {
	require_once(dirname(__FILE__).'/lang/eng.php');
	$pdf->setLanguageArray($l);
}

// ---------------------------------------------------------

// set font
$pdf->SetFont('dejavusans', '', 10);

// add a page
$pdf->AddPage();



ob_start();

	$query = "SELECT *,s.id as customerID,q.id as leadID  FROM `leads_source` AS s, `leads_quotation` AS q WHERE s.id = q.lead_id  AND q.is_booked=1 ";
	$exportTo = strtotime($_POST['exportTo']);
	$exportFrom = strtotime($_POST['exportFrom']);
	if($_POST['customerID'] !== '')
		$query .= " AND s.`id`=  ".$_POST['customerID'];
	if($_POST['customerName'] !== '')
		$query .= " AND s.`full_name` LIKE '%".$_POST['customerName']."%' ";
	if($_POST['customerEmail'] !== '')
		$query .= " AND s.`email_add` LIKE '%".$_POST['customerEmail']."%' ";
	/*if($_POST['customerReferral'] !== '')
		$query .= " AND s.`refferal`='".$_POST['customerReferral']."' ";*/
	if($_POST['customerPhone'] !== '')
		$query .= " AND s.`contact_number` LIKE '%".$_POST['customerPhone']."%' ";
	if($_POST['productID'] !== '')
		$query .= " AND q.`id`=".$_POST['productID']." ";
	if($_POST['productName'] !== '')
		$query .= " AND q.`product_name` LIKE '%".$_POST['productName']."%' ";
	if($_POST['exportTo'] !== '')
		$query .= " AND q.`created_date` > ".$exportTo." ";
	if($_POST['exportFrom'] !== '')
		$query .= " AND q.`created_date` < ".$exportFrom." ";
		
		
	if($_SESSION['user_info']['id'] > 1)			
	$query .= " AND s.created_by =".$_SESSION['user_info']['id'];

	$query .=" ORDER BY s.id DESC";
	$permissionQ = "SELECT * FROM `leads_permissions` WHERE `userid`=".$_SESSION['user_info']['id'];
	$permissionQ_obj = mysqli_query($link , $permissionQ);
	$permissionQRow = mysqli_fetch_assoc($permissionQ_obj); 
	$_PERMISSIONS = json_decode($permissionQRow['permissions'],TRUE);


$query_obj = mysqli_query($link , $query);
if(mysqli_num_rows($query_obj) > 0){	
while($query_obj_row = mysqli_fetch_assoc($query_obj)){   

 ?>               
    <div  class="row left" style="border-bottom:1px solid #dddddd; padding:10px 0; background-color:#f7f7f7">
        <div class="feilds left" style="min-width: 40px;"><?php echo $query_obj_row['customerID']; ?></div>
        <div class="feilds left" style="min-width: 40px;"><?php echo $query_obj_row['leadID']; ?></div>
    	<div class="feilds left"><a href="javascript:void(0);"><?php echo $query_obj_row['full_name']; ?></a></div>
    	<div class="feilds left"><a href="javascript:void(0);"><?php echo $query_obj_row['email_add']; ?></a></div>
    	<div class="feilds left"><?php echo $query_obj_row['contact_number']; ?></div>
    	<div class="feilds left"><a href="javascript:void(0);"><?php echo $query_obj_row['product_name']; ?></a></div>
        <div class="feilds left" style="min-width: 100px;">
<?php if(isset($_PERMISSIONS['customer_view']) || $_SESSION['user_info']['id'] == 1){ ?>
          <a href="javascript:void(0);" class="detailsOrderAction" data-action="details_order" data-module="<?php echo $_REQUEST['module']; ?>" data-url="<?php echo SITEURL;?>" data-parent="search" data-editid="<?php echo $query_obj_row['id']; ?>" data-leadid="<?php echo $query_obj_row['id']; ?>"><img width="20" height="20" src="<?php echo SITEURL;?>/img/icon/detail.png"></a>
<?php }  if(isset($_PERMISSIONS['customer_delete']) || $_SESSION['user_info']['id'] == 1){ ?>
         <a href="javascript:void(0);" class="deleteUserAction" data-action="delete" data-module="<?php echo $_REQUEST['module']; ?>" data-url="<?php echo SITEURL;?>" data-parent="search" data-editid="<?php echo $query_obj_row['id']; ?>"><img width="20" height="20" src="<?php echo SITEURL;?>/img/icon/close.png"></a>
<?php } ?>	                         
        </div>
	</div>
	


	
<?php
	}
}


$html = ob_get_contents();

ob_clean();

$pdf->writeHTML($html, true, false, true, false, '');
$pdf->lastPage();
$pdf->Output('example_006.pdf', 'F');

?>